unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  TForm1 = class(TForm)
    ListBox1: TListBox;
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

// Ceka na pipe, cita podatke iz njega i prikazuje messagebox
function PipeCatch(p : pointer) : Cardinal; stdcall;
var
  fhnd   : Cardinal;
  cbRead : Cardinal;
  buf    : Array[0..255] of Char;
begin
  SetThreadPriority(GetCurrentThread, THREAD_PRIORITY_BELOW_NORMAL);

  repeat
    Sleep(100);

    fhnd := CreateFile('\\?\pipe\IPCTestPipe',
                       GENERIC_READ,
                       FILE_SHARE_READ,
                       nil,
                       OPEN_EXISTING,
                       FILE_ATTRIBUTE_NORMAL,
                       0);
    If ReadFile(fhnd, buf, SizeOf(buf), cbRead, nil) Then
      MessageBox(0, buf, nil, mb_OK);
    CloseHandle(fhnd);
  until 1 <> 1;

  ExitThread(0);
end;

procedure TForm1.FormCreate(Sender: TObject);
var
  tid           : Cardinal;
  hPipe         : THandle;
  cbWritten     : Cardinal;
  param         : Array[0..255] of Char;
  C1            : Integer;
  firstInstance : Boolean;
begin
  firstInstance := WaitForSingleObject(CreateMutex(nil, FALSE, 'Jedinstveno_Ime_Mutexa'), 0) <> wait_TimeOut; // Vraca FALSE ako jedna instanca vec postoji

  If firstInstance Then // Ako je ovo prva instanca, kreiraj thread
    BeginThread(nil, 0, @PipeCatch, nil, 0, tid);

  If ParamStr(1) <> '' Then // Ako je program pozvan sa parametrom
  Begin
    FillChar(param, SizeOf(param), 0);
    For C1 := 1 to Length(ParamStr(1)) Do
      param[C1 - 1] := ParamStr(1)[C1];
    hPipe := CreateNamedPipe('\\?\pipe\IPCTestPipe', // Kreiramo pipe
                             PIPE_ACCESS_DUPLEX,
                             PIPE_TYPE_BYTE + PIPE_READMODE_BYTE + PIPE_WAIT,
                             PIPE_UNLIMITED_INSTANCES,
                             SizeOf(param),
                             SizeOf(param),
                             NMPWAIT_USE_DEFAULT_WAIT,
                             nil);
    If ConnectNamedPipe(hPipe, nil) Then // Cekamo da neko otvori pipe
      If (WriteFile(hPipe, param, SizeOf(param), cbWritten, nil)) and // Zatim zapisujemo podatke u pipe
         (cbWritten = SizeOf(param)) Then
      Begin
      // Na kraju oslobadjamo pipe
        FlushFileBuffers(hPipe);
        DisconnectNamedPipe(hPipe);
        CloseHandle(hPipe);
      End;
  End;

  If not firstInstance Then // Ako ovo nije prva instanc, zatvarmo aplikaciju
     Application.Terminate;
end;

end.
